//+------------------------------------------------------------------+
//|                                                     VCircles.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Black

extern int Complect=0;
extern int timeframe=0;
extern bool over=false;

extern bool main_circles=true;
extern bool fan_lines=true;

extern bool backgr=false;
extern bool stopper=false;
extern bool save=false;
extern bool info=false;

extern color point_col=Blue;
extern color main_circles_radius_col=Red;
extern color main_circles_col=Yellow;
extern color fan_lines_col=Blue;
extern color channel12_col=Green;
extern color channel21_col=Orange;

extern int main_circles_radius_style=2;
extern int main_circles_style=0;
extern int fan_lines_style=0;

extern int point_width=1;
extern int main_circles_radius_width=1;
extern int main_circles_width=1;
extern int fan_lines_width=1;

extern int fplace=34;
extern int splace=5;
extern bool by_time=false;
extern datetime point1_date=D'2007.07.24 00:00';
extern datetime point2_date=D'2007.08.16 00:00';

extern bool handycode=false;
extern int code=108;
extern bool delpoints=false;

datetime prevtime;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(main_circles) ObjectDelete("Main_Circles Complect"+Complect);
   if(fan_lines)
    {
     ObjectDelete("Fan Line1-1 Complect"+Complect);
     ObjectDelete("Fan Line1-3 Complect"+Complect);
     ObjectDelete("Fan Line1-4 Complect"+Complect);
     ObjectDelete("Fan Line3-1 Complect"+Complect);
     ObjectDelete("Fan Line4-1 Complect"+Complect);
     ObjectDelete("Channel1-2 Complect"+Complect);
     ObjectDelete("Channel2-1 Complect"+Complect);
    } 
   if(info) Comment(""); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if(delpoints)
    {
     ObjectDelete("Point1 Complect"+Complect);
     ObjectDelete("Point2 Complect"+Complect);
    }
   if(main_circles) ObjectDelete("Main_Circles Complect"+Complect); 
   if(fan_lines)
    { 
     ObjectDelete("Fan Line1-1 Complect"+Complect);
     ObjectDelete("Fan Line1-3 Complect"+Complect);
     ObjectDelete("Fan Line1-4 Complect"+Complect);
     ObjectDelete("Fan Line3-1 Complect"+Complect);
     ObjectDelete("Fan Line4-1 Complect"+Complect);
     ObjectDelete("Channel1-2 Complect"+Complect);
     ObjectDelete("Channel2-1 Complect"+Complect);
    } 
   if(info) Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int error=GetLastError();
//----
   if(stopper)
    {
     if(prevtime == Time[0]) return(0);
     if(error!=4066) prevtime = Time[0];
    }
//----
   int iH, iL, P, nP1, nP2, nH, nL, nPoint2, nPoint1, i;
   int pointcode, tr, tr1, b1, b2, b3;
   double x1, x2, x3, y1, y2, y3, min, max;
   double period, scale, radius, hradius;
   bool up;
   datetime Date1, Date2;
   string freeze="";
   if(save) freeze=" saved";
//----    
   if(main_circles_radius_style<0 || main_circles_radius_style>4) main_circles_radius_style=2;
   if(main_circles_style<0 || main_circles_style>4) main_circles_style=0;
   if(fan_lines_style<0 || fan_lines_style>4) fan_lines_style=0;
//----   
   if(main_circles) ObjectDelete("Main_Circles Complect"+Complect); 
   if(fan_lines)
    {
     ObjectDelete("Fan Line1-1 Complect"+Complect);
     ObjectDelete("Fan Line1-3 Complect"+Complect);
     ObjectDelete("Fan Line1-4 Complect"+Complect);
     ObjectDelete("Fan Line3-1 Complect"+Complect);
     ObjectDelete("Fan Line4-1 Complect"+Complect);
     ObjectDelete("Channel1-2 Complect"+Complect);
     ObjectDelete("Channel2-1 Complect"+Complect);
    } 
//----
   switch (timeframe)
    {
      case 1:
         period = OBJ_PERIOD_M1;
         break;
      case 5:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5; else period = OBJ_PERIOD_M5;
         break;
      case 15:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15; else period = OBJ_PERIOD_M15;
         break;
      case 30:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30; else period = OBJ_PERIOD_M30;
         break;      
      case 60:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1; else period = OBJ_PERIOD_H1;
         break;
      case 240:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4; else period = OBJ_PERIOD_H4;
         break;
      case 1440:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1; else period = OBJ_PERIOD_D1;
         break;
      case 10080:
         if(over) period = OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4 | OBJ_PERIOD_D1 | OBJ_PERIOD_W1; else period = OBJ_PERIOD_W1;
         break;
      case 43200:
         period = OBJ_PERIOD_MN1;
         break;
      case 0:
         period = NULL;
         break;
      case -1:
         period = EMPTY;
         break;       
    }   
//---- 
   if(handycode) pointcode=code;
   else
    {
     switch (Complect)
      {
       case  0: pointcode = 139; break;
       case  1: pointcode = 140; break;
       case  2: pointcode = 141; break;
       case  3: pointcode = 142; break;
       case  4: pointcode = 143; break;
       case  5: pointcode = 144; break;
       case  6: pointcode = 145; break;
       case  7: pointcode = 146; break;
       case  8: pointcode = 147; break;
       case  9: pointcode = 148; break;
       case 10: pointcode = 149; break;
       case 11: pointcode = 128; break;
       case 12: pointcode = 129; break;
       case 13: pointcode = 130; break;
       case 14: pointcode = 131; break;
       case 15: pointcode = 132; break;
       case 16: pointcode = 133; break;
       case 17: pointcode = 134; break;
       case 18: pointcode = 135; break;
       case 19: pointcode = 136; break;
       case 20: pointcode = 137; break;
       case 21: pointcode = 138; break;
       default: pointcode = code;
      }
    }        
//----
   if(by_time) 
    {
     fplace=iBarShift(NULL,0,point1_date,false);
     splace=iBarShift(NULL,0,point2_date,false);
    }    
   if(ObjectFind("Point1 Complect"+Complect)!=0) ObjectCreate("Point1 Complect"+Complect, OBJ_ARROW, 0, Time[fplace], (High[fplace]+Low[fplace])/2);
   if(ObjectFind("Point2 Complect"+Complect)!=0) ObjectCreate("Point2 Complect"+Complect, OBJ_ARROW, 0, Time[splace], (High[splace]+Low[splace])/2);
//----   
   ObjectSet("Point1 Complect"+Complect,OBJPROP_ARROWCODE,pointcode);
   ObjectSet("Point1 Complect"+Complect,OBJPROP_COLOR,point_col);
   ObjectSet("Point1 Complect"+Complect,OBJPROP_WIDTH,point_width);
   ObjectSet("Point1 Complect"+Complect,OBJPROP_TIMEFRAMES,period);
//----   
   ObjectSet("Point2 Complect"+Complect,OBJPROP_ARROWCODE,pointcode);
   ObjectSet("Point2 Complect"+Complect,OBJPROP_COLOR,point_col);
   ObjectSet("Point2 Complect"+Complect,OBJPROP_WIDTH,point_width);
   ObjectSet("Point2 Complect"+Complect,OBJPROP_TIMEFRAMES,period);
//----    
   Date1=ObjectGet("Point1 Complect"+Complect,OBJPROP_TIME1);
   Date2=ObjectGet("Point2 Complect"+Complect,OBJPROP_TIME1);   
//----  
   nP1=iBarShift(NULL,0,Date1,false);
   nP2=iBarShift(NULL,0,Date2,false);
   if(nP1>nP2)
    {
     P=nP1;
     nP1=nP2;
     nP2=P;
    }
   nH=iHighest(NULL,0,MODE_HIGH,nP2-nP1+1,nP1);
   nL=iLowest(NULL,0,MODE_LOW,nP2-nP1+1,nP1);
   if(nL>nH) up=true;
   else if(nL<nH) up=false;  
   if(up)
    {
     nPoint2=nL;
     nPoint1=nH;
    }
   else
    {
     nPoint2=nH;
     nPoint1=nL;
    }
   if(nPoint2==nPoint1) return(0);
//----
   if(up)
    {
     min=Low[nPoint2];
     max=High[nPoint1];
    }
   else
    {
     min=Low[nPoint1];
     max=High[nPoint2];
    }
//----    
   scale=(max-min)/Point/(nPoint2-nPoint1); 
   if(scale==1.00)
    {
     radius=MathPow((max-min)/Point,2)+MathPow(nPoint2-nPoint1,2);
     tr=NormalizeDouble(nPoint1-MathSqrt(radius)*0.25,0);
     tr1=NormalizeDouble(nPoint1+MathSqrt(radius)*0.5,0);
     x1=radius*0.1875;
     b1=NormalizeDouble(nPoint1-MathSqrt(x1),0);
     x2=radius*0.5;
     b2=NormalizeDouble(nPoint1-MathSqrt(x2),0);
     x3=radius*0.9375;
     b3=NormalizeDouble(nPoint1-MathSqrt(x3),0);
     y1=MathSqrt(radius*0.1875)*Point;
     y2=MathSqrt(radius*0.5)*Point;
     y3=MathSqrt(radius*0.9375)*Point;
     radius=MathSqrt(radius);
    } 
   if(scale>1.00)
    {
     radius=(max-min)/Point*MathSqrt(2);
     tr=NormalizeDouble(nPoint1-radius*0.25/scale,0);
     tr1=NormalizeDouble(nPoint1+radius*0.5/scale,0);
     x1=radius*MathSqrt(0.1875)/scale;
     b1=NormalizeDouble(nPoint1-x1,0);
     x2=radius*MathSqrt(0.5)/scale;
     b2=NormalizeDouble(nPoint1-x2,0);
     x3=radius*MathSqrt(0.9375)/scale;
     b3=NormalizeDouble(nPoint1-x3,0);
     y1=radius*MathSqrt(0.1875)*Point;
     y2=radius*MathSqrt(0.5)*Point;
     y3=radius*MathSqrt(0.9375)*Point;
    }
   if(scale<1.00 && scale>0.00)
    {
     hradius=(nPoint2-nPoint1)*MathSqrt(2);
     radius=(nPoint2-nPoint1)*MathSqrt(2)*scale; 
     tr=NormalizeDouble(nPoint1-hradius*0.25,0);
     tr1=NormalizeDouble(nPoint1+hradius*0.5,0);
     x1=hradius*MathSqrt(0.1875);
     b1=NormalizeDouble(nPoint1-x1,0);
     x2=hradius*MathSqrt(0.5);
     b2=NormalizeDouble(nPoint1-x2,0);
     x3=hradius*MathSqrt(0.9375);
     b3=NormalizeDouble(nPoint1-x3,0);
     y1=radius*MathSqrt(0.1875)*Point;
     y2=radius*MathSqrt(0.5)*Point;
     y3=radius*MathSqrt(0.9375)*Point;
    }  
//----
   if(up)
    {
     if(main_circles)
      {
       if(ObjectFind("Main_Circles Complect"+Complect+freeze)!=0)
       ObjectCreate("Main_Circles Complect"+Complect+freeze,OBJ_FIBOARC,0,Time[nPoint2],min,Time[nPoint1],max);
       ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_SCALE,scale);
      }
     if(fan_lines)
      {
       if(ObjectFind("Fan Line1-1 Complect"+Complect+freeze)!=0){
       if(tr>=0) ObjectCreate("Fan Line1-1 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],High[nPoint1],Time[tr],High[nPoint1]-radius*0.25*Point);
       else ObjectCreate("Fan Line1-1 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],High[nPoint1],Time[0]-tr*Period()*60,High[nPoint1]-radius*0.25*Point);}
       
       if(ObjectFind("Fan Line1-3 Complect"+Complect+freeze)!=0){
       if(b2>=0) ObjectCreate("Fan Line1-3 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],High[nPoint1],Time[b2],High[nPoint1]-radius*0.25*Point);
       else ObjectCreate("Fan Line1-3 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],High[nPoint1],Time[0]-b2*Period()*60,High[nPoint1]-radius*0.25*Point);}
       
       if(ObjectFind("Fan Line1-4 Complect"+Complect+freeze)!=0){
       if(b3>=0) ObjectCreate("Fan Line1-4 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],High[nPoint1],Time[b3],High[nPoint1]-radius*0.25*Point);
       else ObjectCreate("Fan Line1-4 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],High[nPoint1],Time[0]-b3*Period()*60,High[nPoint1]-radius*0.25*Point);}
       
       if(ObjectFind("Fan Line3-1 Complect"+Complect+freeze)!=0){
       if(tr>=0) ObjectCreate("Fan Line3-1 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],High[nPoint1],Time[tr],High[nPoint1]-y2);
       else ObjectCreate("Fan Line3-1 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],High[nPoint1],Time[0]-tr*Period()*60,High[nPoint1]-y2);}
       
       if(ObjectFind("Fan Line4-1 Complect"+Complect+freeze)!=0){
       if(tr>=0) ObjectCreate("Fan Line4-1 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],High[nPoint1],Time[tr],High[nPoint1]-y3);
       else ObjectCreate("Fan Line4-1 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],High[nPoint1],Time[0]-tr*Period()*60,High[nPoint1]-y3);}
       
       if(ObjectFind("Channel1-2 Complect"+Complect+freeze)!=0){
       if(b1>=0) ObjectCreate("Channel1-2 Complect"+Complect+freeze,OBJ_CHANNEL,0,Time[nPoint1],High[nPoint1],Time[b1],High[nPoint1]-radius*0.25*Point,Time[tr1],High[nPoint1]);
       else ObjectCreate("Channel1-2 Complect"+Complect+freeze,OBJ_CHANNEL,0,Time[nPoint1],High[nPoint1],Time[0]-b1*Period()*60,High[nPoint1]-radius*0.25*Point,Time[tr1],High[nPoint1]);}
       
       if(ObjectFind("Channel2-1 Complect"+Complect+freeze)!=0){
       if(tr>=0) ObjectCreate("Channel2-1 Complect"+Complect+freeze,OBJ_CHANNEL,0,Time[nPoint1],High[nPoint1],Time[tr],High[nPoint1]-y1,Time[nPoint1],High[nPoint1]+radius*0.5*Point);
       else ObjectCreate("Channel2-1 Complect"+Complect+freeze,OBJ_CHANNEL,0,Time[nPoint1],High[nPoint1],Time[0]-tr*Period()*60,High[nPoint1]-y1,Time[nPoint1],High[nPoint1]+radius*0.5*Point);}
      } 
//----     
     if(info) Comment("\nC(/) = "+DoubleToStr(scale,2));    
    }
   else
    {
     if(main_circles)
      {
       if(ObjectFind("Main_Circles Complect"+Complect+freeze)!=0)
       ObjectCreate("Main_Circles Complect"+Complect+freeze,OBJ_FIBOARC,0,Time[nPoint2],max,Time[nPoint1],min);
       ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_SCALE,-scale);
      } 
     if(fan_lines)
      {  
       if(ObjectFind("Fan Line1-1 Complect"+Complect+freeze)!=0){
       if(tr>=0) ObjectCreate("Fan Line1-1 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],Low[nPoint1],Time[tr],Low[nPoint1]+radius*0.25*Point);
       else ObjectCreate("Fan Line1-1 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],Low[nPoint1],Time[0]-tr*Period()*60,Low[nPoint1]+radius*0.25*Point);}
       
       if(ObjectFind("Fan Line1-3 Complect"+Complect+freeze)!=0){
       if(b2>=0) ObjectCreate("Fan Line1-3 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],Low[nPoint1],Time[b2],Low[nPoint1]+radius*0.25*Point);
       else ObjectCreate("Fan Line1-3 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],Low[nPoint1],Time[0]-b2*Period()*60,Low[nPoint1]+radius*0.25*Point);}
       
       if(ObjectFind("Fan Line1-4 Complect"+Complect+freeze)!=0){
       if(b3>=0) ObjectCreate("Fan Line1-4 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],Low[nPoint1],Time[b3],Low[nPoint1]+radius*0.25*Point);
       else ObjectCreate("Fan Line1-4 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],Low[nPoint1],Time[0]-b3*Period()*60,Low[nPoint1]+radius*0.25*Point);}
       
       if(ObjectFind("Fan Line3-1 Complect"+Complect+freeze)!=0){
       if(tr>=0) ObjectCreate("Fan Line3-1 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],Low[nPoint1],Time[tr],Low[nPoint1]+y2);
       else ObjectCreate("Fan Line3-1 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],Low[nPoint1],Time[0]-tr*Period()*60,Low[nPoint1]+y2);}
       
       if(ObjectFind("Fan Line4-1 Complect"+Complect+freeze)!=0){
       if(tr>=0) ObjectCreate("Fan Line4-1 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],Low[nPoint1],Time[tr],Low[nPoint1]+y3);
       else ObjectCreate("Fan Line4-1 Complect"+Complect+freeze,OBJ_TREND,0,Time[nPoint1],Low[nPoint1],Time[0]-tr*Period()*60,Low[nPoint1]+y3);}
       
       if(ObjectFind("Channel1-2 Complect"+Complect+freeze)!=0){
       if(b1>=0) ObjectCreate("Channel1-2 Complect"+Complect+freeze,OBJ_CHANNEL,0,Time[nPoint1],Low[nPoint1],Time[b1],Low[nPoint1]+radius*0.25*Point,Time[tr1],Low[nPoint1]);
       else ObjectCreate("Channel1-2 Complect"+Complect+freeze,OBJ_CHANNEL,0,Time[nPoint1],Low[nPoint1],Time[0]-b1*Period()*60,Low[nPoint1]+radius*0.25*Point,Time[tr1],Low[nPoint1]);}
       
       if(ObjectFind("Channel2-1 Complect"+Complect+freeze)!=0){
       if(tr>=0) ObjectCreate("Channel2-1 Complect"+Complect+freeze,OBJ_CHANNEL,0,Time[nPoint1],Low[nPoint1],Time[tr],Low[nPoint1]+y1,Time[nPoint1],Low[nPoint1]-radius*0.5*Point);
       else ObjectCreate("Channel2-1 Complect"+Complect+freeze,OBJ_CHANNEL,0,Time[nPoint1],Low[nPoint1],Time[0]-tr*Period()*60,Low[nPoint1]+y1,Time[nPoint1],Low[nPoint1]-radius*0.5*Point);}
      }
//----     
     if(info) Comment("\nC(/) = "+DoubleToStr(-scale,2));         
    }     
//----
   if(main_circles)
    {
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_COLOR,main_circles_radius_col);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_LEVELCOLOR,main_circles_col);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_STYLE,main_circles_radius_style);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_LEVELSTYLE,main_circles_style);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_WIDTH,main_circles_radius_width);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_LEVELWIDTH,main_circles_width);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_BACK,backgr);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_TIMEFRAMES,period);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_FIBOLEVELS,4);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_FIRSTLEVEL+0,0.25);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_FIRSTLEVEL+1,0.5);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_FIRSTLEVEL+2,0.75);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_FIRSTLEVEL+3,1.00);
     ObjectSet("Main_Circles Complect"+Complect+freeze,OBJPROP_ELLIPSE,true);
    }
   if(fan_lines)
    {
     ObjectSet("Fan Line1-1 Complect"+Complect+freeze,OBJPROP_COLOR,fan_lines_col);
     ObjectSet("Fan Line1-1 Complect"+Complect+freeze,OBJPROP_STYLE,fan_lines_style);
     ObjectSet("Fan Line1-1 Complect"+Complect+freeze,OBJPROP_WIDTH,fan_lines_width);
     ObjectSet("Fan Line1-1 Complect"+Complect+freeze,OBJPROP_BACK,backgr);
     ObjectSet("Fan Line1-1 Complect"+Complect+freeze,OBJPROP_RAY,true);
     ObjectSet("Fan Line1-1 Complect"+Complect+freeze,OBJPROP_TIMEFRAMES,period);
     
     ObjectSet("Fan Line1-3 Complect"+Complect+freeze,OBJPROP_COLOR,fan_lines_col);
     ObjectSet("Fan Line1-3 Complect"+Complect+freeze,OBJPROP_STYLE,fan_lines_style);
     ObjectSet("Fan Line1-3 Complect"+Complect+freeze,OBJPROP_WIDTH,fan_lines_width);
     ObjectSet("Fan Line1-3 Complect"+Complect+freeze,OBJPROP_BACK,backgr);
     ObjectSet("Fan Line1-3 Complect"+Complect+freeze,OBJPROP_RAY,true);
     ObjectSet("Fan Line1-3 Complect"+Complect+freeze,OBJPROP_TIMEFRAMES,period);
     
     ObjectSet("Fan Line1-4 Complect"+Complect+freeze,OBJPROP_COLOR,fan_lines_col);
     ObjectSet("Fan Line1-4 Complect"+Complect+freeze,OBJPROP_STYLE,fan_lines_style);
     ObjectSet("Fan Line1-4 Complect"+Complect+freeze,OBJPROP_WIDTH,fan_lines_width);
     ObjectSet("Fan Line1-4 Complect"+Complect+freeze,OBJPROP_BACK,backgr);
     ObjectSet("Fan Line1-4 Complect"+Complect+freeze,OBJPROP_RAY,true);
     ObjectSet("Fan Line1-4 Complect"+Complect+freeze,OBJPROP_TIMEFRAMES,period);
     
     ObjectSet("Fan Line3-1 Complect"+Complect+freeze,OBJPROP_COLOR,fan_lines_col);
     ObjectSet("Fan Line3-1 Complect"+Complect+freeze,OBJPROP_STYLE,fan_lines_style);
     ObjectSet("Fan Line3-1 Complect"+Complect+freeze,OBJPROP_WIDTH,fan_lines_width);
     ObjectSet("Fan Line3-1 Complect"+Complect+freeze,OBJPROP_BACK,backgr);
     ObjectSet("Fan Line3-1 Complect"+Complect+freeze,OBJPROP_RAY,true);
     ObjectSet("Fan Line3-1 Complect"+Complect+freeze,OBJPROP_TIMEFRAMES,period);
     
     ObjectSet("Fan Line4-1 Complect"+Complect+freeze,OBJPROP_COLOR,fan_lines_col);
     ObjectSet("Fan Line4-1 Complect"+Complect+freeze,OBJPROP_STYLE,fan_lines_style);
     ObjectSet("Fan Line4-1 Complect"+Complect+freeze,OBJPROP_WIDTH,fan_lines_width);
     ObjectSet("Fan Line4-1 Complect"+Complect+freeze,OBJPROP_BACK,backgr);
     ObjectSet("Fan Line4-1 Complect"+Complect+freeze,OBJPROP_RAY,true);
     ObjectSet("Fan Line4-1 Complect"+Complect+freeze,OBJPROP_TIMEFRAMES,period);
     
     ObjectSet("Channel1-2 Complect"+Complect+freeze,OBJPROP_COLOR,channel12_col);
     ObjectSet("Channel1-2 Complect"+Complect+freeze,OBJPROP_STYLE,fan_lines_style);
     ObjectSet("Channel1-2 Complect"+Complect+freeze,OBJPROP_WIDTH,fan_lines_width);
     ObjectSet("Channel1-2 Complect"+Complect+freeze,OBJPROP_BACK,backgr);
     ObjectSet("Channel1-2 Complect"+Complect+freeze,OBJPROP_RAY,true);
     ObjectSet("Channel1-2 Complect"+Complect+freeze,OBJPROP_TIMEFRAMES,period);
     
     ObjectSet("Channel2-1 Complect"+Complect+freeze,OBJPROP_COLOR,channel21_col);
     ObjectSet("Channel2-1 Complect"+Complect+freeze,OBJPROP_STYLE,fan_lines_style);
     ObjectSet("Channel2-1 Complect"+Complect+freeze,OBJPROP_WIDTH,fan_lines_width);
     ObjectSet("Channel2-1 Complect"+Complect+freeze,OBJPROP_BACK,backgr);
     ObjectSet("Channel2-1 Complect"+Complect+freeze,OBJPROP_RAY,true);
     ObjectSet("Channel2-1 Complect"+Complect+freeze,OBJPROP_TIMEFRAMES,period);
    }   
//----
   return(0);
  }
//+------------------------------------------------------------------+